hpp-fcl: boost::serialization::internal::BVHModelBaseAccessor Struct Reference

hpp-fcl 1.7.2 HPP fork of FCL -- The Flexible Collision Library

Public Types | Public Attributes | List of all members
boost::serialization::internal::BVHModelBaseAccessor Struct Reference

`#include <hpp/fcl/serialization/BVH_model.h>`

Inheritance diagram for boost::serialization::internal::BVHModelBaseAccessor:

## Public Types
typedef hpp::fcl::BVHModelBase | Base

## Public Attributes
int | num_tris_allocated
int | num_vertices_allocated
Public Attributes inherited from hpp::fcl::BVHModelBase
Vec3f * | vertices
| Geometry point data. More...
Triangle * | tri_indices
| Geometry triangle index data, will be NULL for point clouds. More...
Vec3f * | prev_vertices
| Geometry point data in previous frame. More...
int | num_tris
| Number of triangles. More...
int | num_vertices
| Number of points. More...
BVHBuildState | build_state
| The state of BVH building process. More...
shared_ptr< ConvexBase > | convex
| Convex<Triangle> representation of this object. More...
Public Attributes inherited from hpp::fcl::CollisionGeometry
Vec3f | aabb_center
| AABB center in local coordinate. More...
FCL_REAL | aabb_radius
| AABB radius. More...
AABB | aabb_local
| AABB in local coordinate, used for tight AABB when only translation transform. More...
void * | user_data
| pointer to user defined data specific to this object More...
FCL_REAL | cost_density
| collision cost for unit volume More...
FCL_REAL | threshold_occupied
| threshold for occupied ( >= is occupied) More...
FCL_REAL | threshold_free
| threshold for free (<= is free) More...

## Additional Inherited Members
Public Member Functions inherited from hpp::fcl::BVHModelBase
BVHModelType | getModelType () const
| Model type described by the instance. More...
| BVHModelBase ()
| Constructing an empty BVH. More...
| BVHModelBase (const BVHModelBase &other)
| copy from another BVH More...
virtual | ~BVHModelBase ()
| deconstruction, delete mesh data related. More...
bool | operator== (const BVHModelBase &other) const
| Comparison operators. More...
bool | operator!= (const BVHModelBase &other) const
| Difference operator. More...
OBJECT_TYPE | getObjectType () const
| Get the object type: it is a BVH. More...
void | computeLocalAABB ()
| Compute the AABB for the BVH, used for broad-phase collision. More...
int | beginModel (int num_tris=0, int num_vertices=0)
| Begin a new BVH model. More...
int | addVertex (const Vec3f &p)
| Add one point in the new BVH model. More...
int | addVertices (const Matrixx3f &points)
| Add points in the new BVH model. More...
int | addTriangles (const Matrixx3i &triangles)
| Add triangles in the new BVH model. More...
int | addTriangle (const Vec3f &p1, const Vec3f &p2, const Vec3f &p3)
| Add one triangle in the new BVH model. More...
int | addSubModel (const std::vector< Vec3f > &ps, const std::vector< Triangle > &ts)
| Add a set of triangles in the new BVH model. More...
int | addSubModel (const std::vector< Vec3f > &ps)
| Add a set of points in the new BVH model. More...
int | endModel ()
| End BVH model construction, will build the bounding volume hierarchy. More...
int | beginReplaceModel ()
| Replace the geometry information of current frame (i.e. should have the same mesh topology with the previous frame) More...
int | replaceVertex (const Vec3f &p)
| Replace one point in the old BVH model. More...
int | replaceTriangle (const Vec3f &p1, const Vec3f &p2, const Vec3f &p3)
| Replace one triangle in the old BVH model. More...
int | replaceSubModel (const std::vector< Vec3f > &ps)
| Replace a set of points in the old BVH model. More...
int | endReplaceModel (bool refit=true, bool bottomup=true)
| End BVH model replacement, will also refit or rebuild the bounding volume hierarchy. More...
int | beginUpdateModel ()
| Replace the geometry information of current frame (i.e. should have the same mesh topology with the previous frame). The current frame will be saved as the previous frame in prev_vertices. More...
int | updateVertex (const Vec3f &p)
| Update one point in the old BVH model. More...
int | updateTriangle (const Vec3f &p1, const Vec3f &p2, const Vec3f &p3)
| Update one triangle in the old BVH model. More...
int | updateSubModel (const std::vector< Vec3f > &ps)
| Update a set of points in the old BVH model. More...
int | endUpdateModel (bool refit=true, bool bottomup=true)
| End BVH model update, will also refit or rebuild the bounding volume hierarchy. More...
void | buildConvexRepresentation (bool share_memory)
| Build this Convex<Triangle> representation of this model. The result is stored in attribute convex. More...
bool | buildConvexHull (bool keepTriangle, const char *qhullCommand=NULL)
| Build a convex hull and store it in attribute convex. More...
virtual int | memUsage (const bool msg=false) const =0
virtual void | makeParentRelative ()=0
| This is a special acceleration: BVH_model default stores the BV's transform in world coordinate. However, we can also store each BV's transform related to its parent BV node. When traversing the BVH, this can save one matrix transformation. More...
Vec3f | computeCOM () const
| compute center of mass More...
FCL_REAL | computeVolume () const
| compute the volume More...
Matrix3f | computeMomentofInertia () const
| compute the inertia matrix, related to the origin More...
Public Member Functions inherited from hpp::fcl::CollisionGeometry
| CollisionGeometry ()
| CollisionGeometry (const CollisionGeometry &other)
| Copy constructor. More...
virtual | ~CollisionGeometry ()
virtual CollisionGeometry * | clone () const =0
| Clone *this into a new CollisionGeometry. More...
bool | operator== (const CollisionGeometry &other) const
| Equality operator. More...
bool | operator!= (const CollisionGeometry &other) const
| Difference operator. More...
virtual NODE_TYPE | getNodeType () const
| get the node type More...
void * | getUserData () const
| get user data in geometry More...
void | setUserData (void *data)
| set user data in geometry More...
bool | isOccupied () const
| whether the object is completely occupied More...
bool | isFree () const
| whether the object is completely free More...
bool | isUncertain () const
| whether the object has some uncertainty More...
virtual Matrix3f | computeMomentofInertiaRelatedToCOM () const
| compute the inertia matrix, related to the com More...
Protected Member Functions inherited from hpp::fcl::BVHModelBase
virtual void | deleteBVs ()=0
virtual bool | allocateBVs ()=0
virtual int | buildTree ()=0
| Build the bounding volume hierarchy. More...
virtual int | refitTree (bool bottomup)=0
| Refit the bounding volume hierarchy. More...
Protected Attributes inherited from hpp::fcl::BVHModelBase
int | num_tris_allocated
int | num_vertices_allocated
int | num_vertex_updated

## Member Typedef Documentation

## ◆ Base

typedef hpp::fcl::BVHModelBase boost::serialization::internal::BVHModelBaseAccessor::Base

## Member Data Documentation

## ◆ num_tris_allocated

int hpp::fcl::BVHModelBase::num_tris_allocated

## ◆ num_vertices_allocated

int hpp::fcl::BVHModelBase::num_vertices_allocated

The documentation for this struct was generated from the following file:

- include/hpp/fcl/serialization/BVH_model.h